#!/bin/sh

set -e

cd $(dirname $0)

. ../../common/config.sh
. ../../common/log.sh

# TBC: should usermod create the home directory?
log_start "$0" "usermod does not move non-directory (regular file)"

save_config

# restore the files on exit
trap 'log_status "$0" "FAILURE"; restore_config; rm -f /home/foo' 0

change_config

touch /home/foo

echo -n "Change the user's home directory (usermod -m -d /home/foo2 foo)..."
usermod -m -d /home/foo2 foo 2>tmp/usermod.err && exit 1 || {
	status=$?
}
echo "OK"

echo -n "Check returned status ($status)..."
test "$status" = "12"
echo "OK"

echo "usermod reported:"
echo "======================================================================="
cat tmp/usermod.err
echo "======================================================================="
echo -n "Check that there were a failure message..."
diff -au data/usermod.err tmp/usermod.err
echo "error message OK."
rm -f tmp/usermod.err

echo "OK"

echo -n "Check the passwd file..."
../../common/compare_file.pl data/passwd /etc/passwd
echo "OK"
echo -n "Check the group file..."
../../common/compare_file.pl config/etc/group /etc/group
echo "OK"
echo -n "Check the shadow file..."
../../common/compare_file.pl config/etc/shadow /etc/shadow
echo "OK"
echo -n "Check the gshadow file..."
../../common/compare_file.pl config/etc/gshadow /etc/gshadow
echo "OK"
echo -n "Check /home/foo was not removed..."
test -f /home/foo
echo "OK"
echo -n "Check the user's home directory was not created..."
test ! -e /home/foo2
echo "OK"

rm -f /home/foo

log_status "$0" "SUCCESS"
restore_config
trap '' 0